# IMSCC

## Usage
Install
```bash
$ npm install --save imscc
```

Use
```javascript
var imscc = require('imscc');

// Route to controller with `request` and `response` objects.
function (req, res) {
  var data = {}; // Perform some work to acquire data
    var options = {
    renderOpts: {
      pretty: false
    },
    // Adapter options depend on the specified adapter.
    // These as some Courseware Adapter options.
    adapterOpts: { 
      useExternal: true,
      environment: 'dev',
      version: 'v1p3t'
    }
  };

  var c = new imscc.Convert(imscc.Adapters.Courseware, data, options, true);
  
  return c.pipe(res);
}
```

## Development
Install
```bash
$ npm i
```

[Test](https://mochajs.org)
```bash
$ npm t
```

[Lint](https://eslint.org)
```bash
# Automatically run post tests
$ npm run lint
```

[Coverage](https://github.com/istanbuljs/nyc)
```bash
# Run and open coverage report
$ npm run report

# Run coverage
$ npm run nyc
```

[Build](https://babeljs.io/en/setup#installation)
```bash
$ npm run build
```

[Publish](https://docs.npmjs.com/getting-started/publishing-npm-packages)
```bash
$ npm version [<newversion> | major | minor | patch | premajor | preminor | prepatch | prerelease | from-git]

# Confirm have latest build `$ npm run build` before publishing
$ npm publish
```
