'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var merge = require('lodash/merge');
var Template = require('./template');
var DEFAULT_OPTIONS = {
  useExternal: false, // create external files for resources.
  environment: 'dev',
  version: 'v1p3t' // v1p3t | v1p2
};

var Adapter = function () {
  function Adapter(input, options) {
    _classCallCheck(this, Adapter);

    this._options = Object.assign({}, DEFAULT_OPTIONS, options);
    this._template = new Template(this._options.version);
    this._ = input;
    this.manifest = {};
    this.external = {};

    this.setup();

    merge(this.manifest, {
      manifest: this._template.MANIFEST
    }, {
      manifest: {
        metadata: this.metadata,
        organizations: this.organizations,
        resources: this.resources
      }
    });

    this.clean();
  }

  /**
   * Create namespaces for object literals. Anything prefixed with '_' will get cleaned up.
   */


  _createClass(Adapter, [{
    key: 'setup',
    value: function setup() {}

    /**
     * Cleans up any temporary variables created during adaption process, denoted by leading '_'.
     */

  }, {
    key: 'clean',
    value: function clean() {
      for (var prop in this) {
        if (prop.startsWith('_')) {
          delete this[prop];
        }
      }
    }

    /**
     * Add external file to archive.
     * @param {string} filename
     * @param {object} contents
     */

  }, {
    key: 'addExternal',
    value: function addExternal(filename, contents) {
      this.external[filename] = contents;
    }
  }]);

  return Adapter;
}();

module.exports = Adapter;