'use strict';

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var merge = require('lodash/merge');
var compact = require('lodash/compact');
var groupBy = require('lodash/groupBy');

var CurriculumStandards = function CurriculumStandards(item, _TEMPLATE) {
  _classCallCheck(this, CurriculumStandards);

  var overrides = {};

  merge(this, {
    $: {
      providerId: item.providerId
    },
    'csm:setOfGUIDs': {
      $: {
        region: item.region,
        version: item.version
      },
      'csm:labelledGUID': item.benchmarks.map(function (benchmark) {
        return {
          'csm:label': compact([benchmark.code, benchmark.desc || benchmark.text]).join(' '),
          'csm:GUID': benchmark.value
        };
      })
    }
  }, overrides);
};

var CurriculumStandardsMetadata = function CurriculumStandardsMetadata(list, TEMPLATE) {
  _classCallCheck(this, CurriculumStandardsMetadata);

  var groupedByRegion = groupBy(list, function (item) {
    return item.authority.name;
  });
  var groupedByRegionAndVersion = {};
  var newList = [];

  for (var region in groupedByRegion) {
    merge(groupedByRegionAndVersion, _defineProperty({}, region, groupBy(groupedByRegion[region], function (item) {
      return item.version;
    })));
  }

  for (var _region in groupedByRegionAndVersion) {
    for (var version in groupedByRegionAndVersion[_region]) {
      newList.push({
        providerId: 'AB',
        region: _region,
        version: version,
        benchmarks: groupedByRegionAndVersion[_region][version]
      });
    }
  }

  merge(this, {
    'csm:curriculumStandardsMetadata': newList.map(function (item) {
      return new CurriculumStandards(item, TEMPLATE);
    })
  });
};

module.exports = CurriculumStandardsMetadata;