'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Transform = require('./transform');
var Build = require('./build');

var Convert = function () {
  /**
   * Combines entire flow for input of 'raw' data to output of XML.
   * @param {class} Adapter
   * @param {object} data
   * @param {object} options
   * @param {boolean} build
   */
  function Convert(Adapter, data, options, build) {
    var _this = this;

    _classCallCheck(this, Convert);

    this.options = options || {};
    // Convert raw data to syntax to adapted syntax for transformation
    this.adapted = new Adapter(data, this.options.adapterOpts);

    // Convert to desired output
    this.transformed = this.transformations;

    // Generate file(s)
    if (build) {
      this.built = new Build(this.transformed);
      this.pipe = function (res) {
        return _this.built.pipe(res);
      };
    }
  }

  _createClass(Convert, [{
    key: 'transformations',
    get: function get() {
      var transformed = {};

      for (var namespace in this.adapted) {
        var filename = void 0;
        var adapted = {};

        // Flatten archive manifest (of files).
        switch (namespace) {
          case 'manifest':
            filename = 'imsmanifest.xml';
            adapted[filename] = this.adapted[namespace];
            transformed[filename] = new Transform(adapted[filename], this.options);
            break;
          case 'external':
            for (var prop in this.adapted[namespace]) {
              filename = prop;
              adapted[filename] = this.adapted[namespace][filename];
              transformed[filename] = new Transform(adapted[filename], this.options);
            }
            break;
        }
      }

      return transformed;
    }
  }]);

  return Convert;
}();

module.exports = Convert;