'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var merge = require('lodash/merge');
var VERSIONS = require('./versions');

/**
 * The templates define the minimal properties required and the order of nodes.
 */

/**
 * Minimum valid imsmanifest.xml
 * http://membervalidator.imsglobal.org/cc/index.jsp?validate=manifest
 */
var MANIFEST = {
  $: {
    identifier: null,
    xmlns: null,
    'xmlns:lomr': null,
    'xmlns:lomm': null,
    'xmlns:xsi': 'http://www.w3.org/2001/XMLSchema-instance',
    'xmlns:wl': null,
    'xmlns:csm': null,
    'xsi:schemaLocation': null
  },
  metadata: {
    schema: null,
    schemaversion: null,
    'lomm:lom': null
  },
  organizations: {
    organization: {
      $: {
        identifier: 'TOC',
        structure: 'rooted-hierarchy'
      },
      item: {
        $: {
          identifier: 'root'
        }
      }
    }
  },
  resources: {}
};

var ORGANIZATIONS = {
  ITEM: {
    $: {
      identifier: null
    },
    title: null
  }

  /**
   * Resources declared wholly in the manifest.
   */
};var RESOURCES = {
  WEB_LINK: {
    $: {
      identifier: null,
      type: null
    },
    metadata: null,
    'wl:webLink': {
      $: {
        xmlns: null,
        'xmlns:xsi': 'http://www.w3.org/2001/XMLSchema-instance',
        'xsi:schemaLocation': null
      },
      'wl:title': null,
      'wl:url': {
        $: {
          href: null
        }
      }
    }
  },
  BASIC_LTI_LINK: {
    $: {
      identifier: null,
      type: null
    },
    metadata: null
  }

  /**
   * Resources referenced in the manifest to other files within the common cartridge.
   */
};var EXTERNAL_RESOURCES = {
  WEB_LINK: {
    REFERENCE: {
      $: {
        identifier: null,
        type: null
      },
      metadata: null,
      file: {
        $: {
          href: null
        }
      }
    },
    FILE: {
      $: {
        xmlns: null,
        'xmlns:xsi': 'http://www.w3.org/2001/XMLSchema-instance',
        'xsi:schemaLocation': null
      },
      title: null,
      url: {
        $: {
          href: null
        }
      }
    }
  },
  BASIC_LTI_LINK: {
    REFERENCE: {
      $: {
        identifier: null,
        type: null
      },
      metadata: null,
      file: {
        $: {
          href: null
        }
      }
    },
    FILE: {
      $: {
        xmlns: null,
        'xmlns:blti': null,
        'xmlns:lticm': null,
        'xmlns:lticp': null,
        'xmlns:xsi': 'http://www.w3.org/2001/XMLSchema-instance',
        'xsi:schemaLocation': null
      },
      'blti:title': null,
      'blti:description': null,
      'blti:custom': null,
      'blti:extensions': null,
      'blti:launch_url': null,
      'blti:vendor': null
    }
  }
};

var Template = function Template(version) {
  _classCallCheck(this, Template);

  var V = String(version).toUpperCase();

  this.VERSION = VERSIONS[V] ? V : 'V1P3T';
  this.TEMPLATE = VERSIONS[this.VERSION];

  this.MANIFEST = merge({}, MANIFEST, this.TEMPLATE.MANIFEST);
  this.ORGANIZATIONS = merge({}, ORGANIZATIONS, this.TEMPLATE.ORGANIZATIONS);
  this.RESOURCES = merge({}, RESOURCES, this.TEMPLATE.RESOURCES);
  this.EXTERNAL_RESOURCES = merge({}, EXTERNAL_RESOURCES, this.TEMPLATE.EXTERNAL_RESOURCES);
};

module.exports = Template;