'use strict';

/**
 * Minimum valid imsmanifest.xml
 * http://membervalidator.imsglobal.org/cc/index.jsp?validate=manifest
 */
var MANIFEST = {
  $: {
    identifier: 'tcc_v1p3',
    xmlns: 'http://www.imsglobal.org/xsd/imsccv1p3/imscp_v1p1',
    'xmlns:lomr': 'http://ltsc.ieee.org/xsd/imsccv1p3/LOM/resource',
    'xmlns:lomm': 'http://ltsc.ieee.org/xsd/imsccv1p3/LOM/manifest',
    'xmlns:xsi': 'http://www.w3.org/2001/XMLSchema-instance',
    'xmlns:wl': 'http://www.imsglobal.org/xsd/imsccv1p3/imswl_v1p3',
    'xmlns:csm': 'http://www.imsglobal.org/xsd/imsccv1p3/imscsmd_v1p0',
    'xsi:schemaLocation': ['http://www.imsglobal.org/xsd/imsccv1p3/imscp_v1p1', 'http://www.imsglobal.org/profile/cc/ccv1p3/ccv1p3_imscp_v1p2_v1p0.xsd', 'http://ltsc.ieee.org/xsd/imsccv1p3/LOM/resource', 'http://www.imsglobal.org/profile/cc/ccv1p3/LOM/ccv1p3_lomresource_v1p0.xsd', 'http://ltsc.ieee.org/xsd/imsccv1p3/LOM/manifest', 'http://www.imsglobal.org/profile/cc/ccv1p3/LOM/ccv1p3_lommanifest_v1p0.xsd', 'http://www.imsglobal.org/xsd/imsccv1p3/imswl_v1p3', 'http://www.imsglobal.org/profile/cc/ccv1p3/ccv1p3_imswl_v1p3.xsd', 'http://www.imsglobal.org/xsd/imsccv1p3/imscsmd_v1p0', 'http://www.imsglobal.org/profile/cc/ccv1p3/ccv1p3_imscsmd_v1p0.xsd'].join(' ')
  },
  metadata: {
    schema: 'IMS Thin Common Cartridge',
    schemaversion: '1.3.0',
    'lomm:lom': null
  },
  organizations: {
    organization: {
      $: {
        identifier: 'TOC',
        structure: 'rooted-hierarchy'
      },
      item: {
        $: {
          identifier: 'root'
        }
      }
    }
  },
  resources: {}
};

var ORGANIZATIONS = {
  ITEM: {
    $: {
      identifier: null
    },
    title: null
  }

  /**
   * Resources declared wholly in the manifest.
   */
};var RESOURCES = {
  WEB_LINK: {
    $: {
      identifier: null,
      type: 'imswl_xmlv1p3'
    },
    metadata: null,
    'wl:webLink': {
      $: {
        xmlns: 'http://www.imsglobal.org/xsd/imsccv1p3/imswl_v1p3',
        'xmlns:xsi': 'http://www.w3.org/2001/XMLSchema-instance',
        'xsi:schemaLocation': ['http://www.imsglobal.org/xsd/imsccv1p3/imswl_v1p3', 'http://www.imsglobal.org/profile/cc/ccv1p3/ccv1p3_imswl_v1p3.xsd'].join(' ')
      },
      'wl:title': null,
      'wl:url': {
        $: {
          href: null
        }
      }
    }
  },
  BASIC_LTI_LINK: {
    $: {
      identifier: null,
      type: 'imsbasiclti_xmlv1p3'
    },
    metadata: null
  }

  /**
   * Resources referenced in the manifest to other files within the common cartridge.
   */
};var EXTERNAL_RESOURCES = {
  WEB_LINK: {
    REFERENCE: {
      $: {
        identifier: null,
        type: 'imswl_xmlv1p3'
      },
      metadata: null,
      file: {
        $: {
          href: null
        }
      }
    },
    FILE: {
      $: {
        xmlns: 'http://www.imsglobal.org/xsd/imsccv1p3/imswl_v1p3',
        'xmlns:xsi': 'http://www.w3.org/2001/XMLSchema-instance',
        'xsi:schemaLocation': ['http://www.imsglobal.org/xsd/imsccv1p3/imswl_v1p3', 'http://www.imsglobal.org/profile/cc/ccv1p3/ccv1p3_imswl_v1p3.xsd'].join(' ')
      },
      title: null,
      url: {
        $: {
          href: null
        }
      }
    }
  },
  BASIC_LTI_LINK: {
    REFERENCE: {
      $: {
        identifier: null,
        type: 'imsbasiclti_xmlv1p3'
      },
      metadata: null,
      file: {
        $: {
          href: null
        }
      }
    },
    FILE: {
      $: {
        xmlns: 'http://www.imsglobal.org/xsd/imslticc_v1p3',
        'xmlns:blti': 'http://www.imsglobal.org/xsd/imsbasiclti_v1p0',
        'xmlns:lticm': 'http://www.imsglobal.org/xsd/imslticm_v1p0',
        'xmlns:lticp': 'http://www.imsglobal.org/xsd/imslticp_v1p0',
        'xmlns:xsi': 'http://www.w3.org/2001/XMLSchema-instance',
        'xsi:schemaLocation': ['http://www.imsglobal.org/xsd/imslticc_v1p3', 'http://www.imsglobal.org/xsd/lti/ltiv1p3/imslticc_v1p3.xsd', 'http://www.imsglobal.org/xsd/imslticp_v1p0', 'http://www.imsglobal.org/xsd/lti/ltiv1p0/imslticp_v1p0.xsd', 'http://www.imsglobal.org/xsd/imslticm_v1p0', 'http://www.imsglobal.org/xsd/lti/ltiv1p0/imslticm_v1p0.xsd', 'http://www.imsglobal.org/xsd/imsbasiclti_v1p0', 'http://www.imsglobal.org/xsd/lti/ltiv1p0/imsbasiclti_v1p0p1.xsd'].join(' ')
      },
      'blti:title': null,
      'blti:description': null,
      'blti:custom': null,
      'blti:extensions': null,
      'blti:launch_url': null,
      'blti:vendor': null
    }
  }
};

module.exports = {
  MANIFEST: MANIFEST,
  ORGANIZATIONS: ORGANIZATIONS,
  RESOURCES: RESOURCES,
  EXTERNAL_RESOURCES: EXTERNAL_RESOURCES
};