'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var xml2js = require('xml2js');

/**
 * https://github.com/Leonidas-from-XIV/node-xml2js#options-for-the-builder-class
 */
var BUILDER_OPTIONS = {
  renderOpts: {
    pretty: true
  },
  xmldec: {
    version: '1.0',
    encoding: 'UTF-8'
  }

  /**
   * https://www.npmjs.com/package/xml2js#options
   */
};var PARSER_OPTIONS = {
  explicitRoot: false,
  async: false

  /**
   * Wrapper around `xml2js` Builder
   * https://github.com/Leonidas-from-XIV/node-xml2js#xml-builder-usage
   */
};
var Transform = function () {
  /**
   * @param {object} input `xml2js` builder syntax hash
   * @param {object} options Option overrides to baseline BUILDER_OPTIONS
   */
  function Transform(input, builderOpts) {
    var _this = this;

    _classCallCheck(this, Transform);

    var builder = new xml2js.Builder(Object.assign({}, BUILDER_OPTIONS, builderOpts));

    this._input = input;

    this._xml = builder.buildObject(input);

    xml2js.parseString(this._xml, PARSER_OPTIONS, function (_err, js) {
      _this._js = js;
    });
  }

  _createClass(Transform, [{
    key: 'js',
    get: function get() {
      return this._js;
    }
  }, {
    key: 'xml',
    get: function get() {
      return this._xml;
    }
  }, {
    key: 'raw',
    get: function get() {
      return this._input;
    }
  }]);

  return Transform;
}();

module.exports = Transform;