'use strict';

var V1P3T = {
  MANIFEST: {
    $: {
      identifier: 'tcc_v1p3',
      xmlns: 'http://www.imsglobal.org/xsd/imsccv1p3/imscp_v1p1',
      'xmlns:lomr': 'http://ltsc.ieee.org/xsd/imsccv1p3/LOM/resource',
      'xmlns:lomm': 'http://ltsc.ieee.org/xsd/imsccv1p3/LOM/manifest',
      'xmlns:wl': 'http://www.imsglobal.org/xsd/imsccv1p3/imswl_v1p3',
      'xmlns:csm': 'http://www.imsglobal.org/xsd/imsccv1p3/imscsmd_v1p0',
      'xsi:schemaLocation': ['http://www.imsglobal.org/xsd/imsccv1p3/imscp_v1p1', 'http://www.imsglobal.org/profile/cc/ccv1p3/ccv1p3_imscp_v1p2_v1p0.xsd', 'http://ltsc.ieee.org/xsd/imsccv1p3/LOM/resource', 'http://www.imsglobal.org/profile/cc/ccv1p3/LOM/ccv1p3_lomresource_v1p0.xsd', 'http://ltsc.ieee.org/xsd/imsccv1p3/LOM/manifest', 'http://www.imsglobal.org/profile/cc/ccv1p3/LOM/ccv1p3_lommanifest_v1p0.xsd', 'http://www.imsglobal.org/xsd/imsccv1p3/imswl_v1p3', 'http://www.imsglobal.org/profile/cc/ccv1p3/ccv1p3_imswl_v1p3.xsd', 'http://www.imsglobal.org/xsd/imsccv1p3/imscsmd_v1p0', 'http://www.imsglobal.org/profile/cc/ccv1p3/ccv1p3_imscsmd_v1p0.xsd'].join(' ')
    },
    metadata: {
      schema: 'IMS Thin Common Cartridge',
      schemaversion: '1.3.0'
    }
  },
  RESOURCES: {
    WEB_LINK: {
      $: {
        type: 'imswl_xmlv1p3'
      },
      'wl:webLink': {
        $: {
          xmlns: 'http://www.imsglobal.org/xsd/imsccv1p3/imswl_v1p3',
          'xsi:schemaLocation': ['http://www.imsglobal.org/xsd/imsccv1p3/imswl_v1p3', 'http://www.imsglobal.org/profile/cc/ccv1p3/ccv1p3_imswl_v1p3.xsd'].join(' ')
        }
      }
    },
    BASIC_LTI_LINK: {
      $: {
        type: 'imsbasiclti_xmlv1p3'
      }
    }
  },
  EXTERNAL_RESOURCES: {
    WEB_LINK: {
      REFERENCE: {
        $: {
          type: 'imswl_xmlv1p3'
        }
      },
      FILE: {
        $: {
          xmlns: 'http://www.imsglobal.org/xsd/imsccv1p3/imswl_v1p3',
          'xsi:schemaLocation': ['http://www.imsglobal.org/xsd/imsccv1p3/imswl_v1p3', 'http://www.imsglobal.org/profile/cc/ccv1p3/ccv1p3_imswl_v1p3.xsd'].join(' ')
        }
      }
    },
    BASIC_LTI_LINK: {
      REFERENCE: {
        $: {
          type: 'imsbasiclti_xmlv1p3'
        }
      },
      FILE: {
        $: {
          xmlns: 'http://www.imsglobal.org/xsd/imslticc_v1p3',
          'xmlns:blti': 'http://www.imsglobal.org/xsd/imsbasiclti_v1p0',
          'xmlns:lticm': 'http://www.imsglobal.org/xsd/imslticm_v1p0',
          'xmlns:lticp': 'http://www.imsglobal.org/xsd/imslticp_v1p0',
          'xsi:schemaLocation': ['http://www.imsglobal.org/xsd/imslticc_v1p3', 'http://www.imsglobal.org/xsd/lti/ltiv1p3/imslticc_v1p3.xsd', 'http://www.imsglobal.org/xsd/imslticp_v1p0', 'http://www.imsglobal.org/xsd/lti/ltiv1p0/imslticp_v1p0.xsd', 'http://www.imsglobal.org/xsd/imslticm_v1p0', 'http://www.imsglobal.org/xsd/lti/ltiv1p0/imslticm_v1p0.xsd', 'http://www.imsglobal.org/xsd/imsbasiclti_v1p0', 'http://www.imsglobal.org/xsd/lti/ltiv1p0/imsbasiclti_v1p0p1.xsd'].join(' ')
        }
      }
    }
  }
};
var V1P2 = {
  MANIFEST: {
    $: {
      identifier: 'cc_v1p2',
      xmlns: 'http://www.imsglobal.org/xsd/imsccv1p2/imscp_v1p1',
      'xmlns:lomr': 'http://ltsc.ieee.org/xsd/imsccv1p2/LOM/resource',
      'xmlns:lomm': 'http://ltsc.ieee.org/xsd/imsccv1p2/LOM/manifest',
      'xmlns:wl': 'http://www.imsglobal.org/xsd/imsccv1p2/imswl_v1p2',
      'xmlns:csm': 'http://www.imsglobal.org/xsd/imsccv1p2/imscsmd_v1p0',
      'xsi:schemaLocation': ['http://www.imsglobal.org/xsd/imsccv1p2/imscp_v1p1', 'http://www.imsglobal.org/profile/cc/ccv1p2/ccv1p2_imscp_v1p2_v1p0.xsd', 'http://ltsc.ieee.org/xsd/imsccv1p2/LOM/resource', 'http://www.imsglobal.org/profile/cc/ccv1p2/LOM/ccv1p2_lomresource_v1p0.xsd', 'http://ltsc.ieee.org/xsd/imsccv1p2/LOM/manifest', 'http://www.imsglobal.org/profile/cc/ccv1p2/LOM/ccv1p2_lommanifest_v1p0.xsd', 'http://www.imsglobal.org/xsd/imsccv1p2/imswl_v1p2', 'http://www.imsglobal.org/profile/cc/ccv1p2/ccv1p2_imswl_v1p2.xsd', 'http://www.imsglobal.org/xsd/imsccv1p2/imscsmd_v1p0', 'http://www.imsglobal.org/profile/cc/ccv1p2/ccv1p2_imscsmd_v1p0.xsd'].join(' ')
    },
    metadata: {
      schema: 'IMS Common Cartridge',
      schemaversion: '1.2.0'
    }
  },
  RESOURCES: {
    WEB_LINK: {
      $: {
        type: 'imswl_xmlv1p2'
      },
      'wl:webLink': {
        $: {
          xmlns: 'http://www.imsglobal.org/xsd/imsccv1p2/imswl_v1p2',
          'xsi:schemaLocation': ['http://www.imsglobal.org/xsd/imsccv1p2/imswl_v1p2', 'http://www.imsglobal.org/profile/cc/ccv1p2/ccv1p2_imswl_v1p2.xsd'].join(' ')
        }
      }
    },
    BASIC_LTI_LINK: {
      $: {
        type: 'imsbasiclti_xmlv1p0'
      }
    }
  },
  EXTERNAL_RESOURCES: {
    WEB_LINK: {
      REFERENCE: {
        $: {
          type: 'imswl_xmlv1p2'
        }
      },
      FILE: {
        $: {
          xmlns: 'http://www.imsglobal.org/xsd/imsccv1p2/imswl_v1p2',
          'xsi:schemaLocation': ['http://www.imsglobal.org/xsd/imsccv1p2/imswl_v1p2', 'http://www.imsglobal.org/profile/cc/ccv1p2/ccv1p2_imswl_v1p2.xsd'].join(' ')
        }
      }
    },
    BASIC_LTI_LINK: {
      REFERENCE: {
        $: {
          type: 'imsbasiclti_xmlv1p0'
        }
      },
      FILE: {
        $: {
          xmlns: 'http://www.imsglobal.org/xsd/imslticc_v1p0',
          'xmlns:blti': 'http://www.imsglobal.org/xsd/imsbasiclti_v1p0',
          'xmlns:lticm': 'http://www.imsglobal.org/xsd/imslticm_v1p0',
          'xmlns:lticp': 'http://www.imsglobal.org/xsd/imslticp_v1p0',
          'xsi:schemaLocation': ['http://www.imsglobal.org/xsd/imslticc_v1p0', 'http://www.imsglobal.org/xsd/lti/ltiv1p0/imslticc_v1p0p1.xsd', 'http://www.imsglobal.org/xsd/imslticp_v1p0', 'http://www.imsglobal.org/xsd/lti/ltiv1p0/imslticp_v1p0.xsd', 'http://www.imsglobal.org/xsd/imslticm_v1p0', 'http://www.imsglobal.org/xsd/lti/ltiv1p0/imslticm_v1p0.xsd', 'http://www.imsglobal.org/xsd/imsbasiclti_v1p0', 'http://www.imsglobal.org/xsd/lti/ltiv1p0/imsbasiclti_v1p0p1.xsd'].join(' ')
        }
      }
    }
  }
};

var VERSIONS = {
  V1P3T: V1P3T,
  V1P2: V1P2
};

module.exports = Object.assign({}, VERSIONS, {
  supported: Object.keys(VERSIONS).map(function (v) {
    return v.toLowerCase();
  })
});